#ifndef FONT_H
#define FONT_H

#include "libpdf/pdfmisc.h"
#include "libpdf/pdfdictionary.h"
#include "libpdf/pdfdocument.h"

typedef PDF_Dictionary PDF_Font;

typedef enum {PDF_FONT_FIXEDPITCH=(1<<0), PDF_FONT_SERIF=(1<<1), PDF_FONT_SYMBOLIC=(1<<2), PDF_FONT_SCRIPT=(1<<3), PDF_FONT_NONSYMBOLIC=(1<<5),
			  PDF_FONT_ITALIC=(1<<6), PDF_FONT_ALLCAP=(1<<16), PDF_FONT_SMALLCAP=(1<<17), PDF_FONT_FORCEBOLD=(1<<18)} PDF_Font_Flags;
typedef enum {PDF_FONT_COURIER=0, PDF_FONT_COURIERBOLD=1, PDF_FONT_COURIEROBLIQUE=2, PDF_FONT_COURIERBOLDOBLIQUE=3,
			  PDF_FONT_HELVETICA=4, PDF_FONT_HELVETICABOLD=5, PDF_FONT_HELVETICAOBLIQUE=6, PDF_FONT_HELVETICABOLDOBLIQUE=7,
			  PDF_FONT_TIMESROMAN=8, PDF_FONT_TIMESBOLD=9, PDF_FONT_TIMESITALIC=10, PDF_FONT_TIMESBOLDITALIC=11,
			  PDF_FONT_SYMBOL=12, PDF_FONT_ZAPFDINGBATS=13} PDF_FontName;

PDF_Font PDF_Font_new_standard(PDF_Document doc, PDF_FontName name);
PDF_Font PDF_Font_new_embed(PDF_Document doc, PDF_CString fontdata, int fontsize);
PDF_Font PDF_Font_new_embed_file(PDF_Document doc, PDF_CString fname);
PDF_CString PDF_Font_get_basefont(PDF_Font obj);
#endif
