#ifndef QUEUE_H
#define QUEUE_H

typedef struct PDF_queue_node *PDF_Queue_Node;
typedef struct PDF_queue *PDF_Queue;

#include "libpdf/pdfxref.h"

#include "libpdf/pdfheader.h"
#include "libpdf/pdfobject.h"

struct PDF_queue_node {
	PDF_Object data;
	PDF_Queue_Node next;
};

struct PDF_queue {
	struct PDF_header header;
	PDF_CString before;
	PDF_CString between;
	PDF_CString after;
	PDF_Queue_Node first;
	PDF_Queue_Node last;
};

PDF_Queue PDF_Queue_new(PDF_CString before, PDF_CString between, PDF_CString after);
void PDF_Queue_delete(PDF_Queue queue);
PDF_CString PDF_Queue_get_before(PDF_Queue queue);
PDF_CString PDF_Queue_get_between(PDF_Queue queue);
PDF_CString PDF_Queue_get_after(PDF_Queue queue);
int PDF_Queue_write(PDF_Queue queue, FILE *ostream, int index,
					PDF_CBool put_indirect,
					PDF_Xref_Table xref, PDF_Queue indqueue);
				  
PDF_Queue_Node PDF_Queue_Node_new(PDF_Object obj);
PDF_Queue_Node PDF_Queue_Node_free(PDF_Queue_Node node);

PDF_Queue_Node PDF_Queue_get_first(PDF_Queue queue);
PDF_Queue_Node PDF_Queue_get_last(PDF_Queue queue);
PDF_CBool PDF_Queue_append(PDF_Queue queue, PDF_Object newobj);
PDF_CBool PDF_Queue_append_op(PDF_Queue queue, PDF_CString format, ...);

PDF_Object PDF_Queue_Node_get_data(PDF_Queue_Node node);
PDF_Queue_Node PDF_Queue_Node_get_next(PDF_Queue_Node node);

#endif
