#ifndef TEXT_H
#define TEXT_H

typedef enum {PDF_TEXT_FILL=0, PDF_TEXT_STROKE=1, PDF_TEXT_FILLSTROKE=2, PDF_TEXT_INVISIBLE=3, PDF_TEXT_FILLCLIP=4, PDF_TEXT_STROKECLIP=5, PDF_TEXT_FILLSTROKECLIP=6, PDF_TEXT_CLIP=7} PDF_Text_Render_Mode;

#include "libpdf/pdfqueue.h"

typedef PDF_Queue PDF_Text;

#include "libpdf/pdffont.h"

PDF_Text PDF_Text_new(PDF_Graphics contentstream);

/* Text state operators */
PDF_CBool PDF_Text_set_charSpace(PDF_Text text, float space);
PDF_CBool PDF_Text_set_wordSpace(PDF_Text text, float space);
PDF_CBool PDF_Text_set_scale(PDF_Text text, float scale);
PDF_CBool PDF_Text_set_leading(PDF_Text text, float leading);
PDF_CBool PDF_Text_set_font(PDF_Text text, PDF_Font font, float size);
PDF_CBool PDF_Text_set_render(PDF_Text text, PDF_Text_Render_Mode rendermode);
PDF_CBool PDF_Text_set_rise(PDF_Text text, float rise);

/* Text positioning operators */
PDF_CBool PDF_Text_newline_xy(PDF_Text text, float xoff, float yoff);
PDF_CBool PDF_Text_newline_leading(PDF_Text text, float xoff, float yoff);
PDF_CBool PDF_Text_set_matrix(PDF_Text text,
							 float a, float b, float c,
							 float d, float e, float f);
PDF_CBool PDF_Text_newline(PDF_Text text);

/* Text showing operators */
PDF_CBool PDF_Text_string(PDF_Text text, PDF_CString string);
PDF_CBool PDF_Text_newline_string(PDF_Text text, PDF_CString string);
PDF_CBool PDF_Text_space_string(PDF_Text text, float w, float c,
							   PDF_CString string);
PDF_CBool PDF_Text_array(PDF_Text text, PDF_Object arr);
#endif
