#include <sys/stat.h>
#include <ft2build.h>
#include FT_FREETYPE_H
#include <libpdf/pdf.h>

main() {

	PDF_Document doc;
	PDF_Page page;
	PDF_Font font1, font2;
	PDF_Text text1;
	PDF_Graphics stream1;
	
	int numwritten;

	/* create a document */
	doc = PDF_Document_new(612.0, 792.0);

	/* create a page and add it to the document */
	page = PDF_Page_new(doc);

	/* get barcode and Courier fonts */
	font1 = PDF_Font_new_embed_file(doc, "Code39.ttf");
	font2 = PDF_Font_new_standard(doc, PDF_FONT_COURIER);
	
	/* create a stream and attach it to the page */
	stream1 = PDF_PageContent_new(page);
	
	/* create a text object, define the text, and add it to the stream */
	text1 = PDF_Text_new(stream1);

	PDF_Text_set_font(text1, font2, 12.0);
	PDF_Text_newline_xy(text1, 0.0, 700.0);
	PDF_Text_string(text1, "*0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. $/+%*");
	
	PDF_Text_set_font(text1, font1, 12.0);
	PDF_Text_newline_xy(text1, 0, -20.0);
	PDF_Text_string(text1, "*0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. $/+%*");
	
	/* put document to standard out */
	numwritten = PDF_Document_write(doc, stdout);

	return 0;
}

	
