#include <stdio.h>

#include "libpdf/pdfdocument.h"
#include "libpdf/pdffont.h"
#include "libpdf/pdfform.h"
#include "libpdf/pdfgraphics.h"
#include "libpdf/pdfpath.h"
#include "libpdf/pdftext.h"

main() {
	PDF_Document doc;
	PDF_Page page;
	PDF_Font helvetica, courier;
	PDF_Text text1;
	PDF_Graphics graphic1;
	PDF_Graphics graphic2;
	PDF_Form form;
	PDF_Field field1;
	
	int numwritten;

	/* create a document */
	doc = PDF_Document_new(612.0, 792.0);

	/* list of standard fonts to be used in document */
	helvetica = PDF_Font_new_standard(doc, PDF_FONT_HELVETICA);
	courier = PDF_Font_new_standard(doc, PDF_FONT_COURIER);

	/* create a page and add it to the document */
	page = PDF_Page_new(doc);
	
	/* create a content stream and attach it to the page */
	graphic2 = PDF_PageContent_new(page);

	/*  create a form object and attach it to the document */
	form = PDF_Form_new(doc, courier, 12.0);
	
	/* Create the user prompts */
	text1 = PDF_Text_new(graphic2);
	PDF_Text_set_font(text1, helvetica, 12.0);
	PDF_Text_newline_xy(text1, 100.0, 150.0);
	PDF_Text_string(text1, "First Field:");
	PDF_Text_newline_xy(text1, 0, -20.0);
	PDF_Text_string(text1, "Second Field:");

	/* Give some lines to put the fields on */
	graphic1 = PDF_PageContent_new(page);
	PDF_Path_move(graphic1, 175.0, 150.0);
	PDF_Path_line(graphic1, 275.0, 150.0);
	PDF_Path_move(graphic1, 175.0, 130.0);
	PDF_Path_line(graphic1, 275.0, 130.0);
	PDF_Path_paint(graphic1, PDF_CBOOL_FALSE, PDF_CBOOL_TRUE, PDF_CBOOL_FALSE, PDF_FILL_EVENODD);
	
	/*  create a field and attach it to the form */
	PDF_FormFieldText_new(form, page, 175.0, 150.0, 100.0, 12.0);
	PDF_FormFieldText_new(form, page, 175.0, 130.0, 100.0, 12.0);
	
	/* put document to standard out */
	numwritten = PDF_Document_write(doc, stdout);

	return 0;
}

	
