#include <stdio.h>
#include <pgm.h>
#include <libpdf/pdf.h>

main() {
	FILE *imagefile;

	gray **inbuf;
	int rows, cols, maxval;
	
	PDF_Document doc;
	PDF_Page page;
	PDF_Font font1;
	PDF_Graphics graphic1;
	PDF_Image image1;
	
	int numwritten;

	/* create a document */
	doc = PDF_Document_new(612.0, 792.0);

	/* create a page */
	page = PDF_Page_new(doc);

	/* create a content stream and attach it to the page */
	graphic1 = PDF_PageContent_new(page);

	/* get an image to display */
	imagefile =  fopen("kitten.pgm", "r");
	inbuf = pgm_readpgm(imagefile, &cols, &rows, &maxval);
	image1 = PDF_Image_new_pgm(doc, inbuf, cols, rows, maxval);
	
	/* Put the image
	   in the graphics object.  We'll display it half-size, at the top
	   center of the page */
	PDF_Graphics_translate(graphic1, (612-cols/2)/2, 792-rows/2);
	PDF_Graphics_scale(graphic1, cols/2, rows/2);
	PDF_Graphics_append(graphic1, image1);

	/* put document to standard out */
	numwritten = PDF_Document_write(doc, stdout);

	return 0;
}

	
